package graph.input.file;

import java.io.File;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import graph.extractor.graph.builder.BuilderFactory;

public abstract class InputFactory {
	
	protected InputFolder folder;
	
	
	
	public InputFactory(InputFolder folder)
	{
		this.folder = folder;
		
	}
	
	/**Date will be in day month year without separator*/
	
	public List<File> getFilesFromDate(File date)
	{
		List<File> DOs = new ArrayList<File>();
		if(date.isDirectory())
		{
			DOs = Arrays.asList( date.listFiles());
		}
		return DOs;
		
	}
	
	
	
	public List<String> getAllProcess(File oneDayOfDO)
	{
		
		List<File>  AllFilesOfthatDay = this.getFilesFromDate(oneDayOfDO);
		List<String> allProcess  =  this.readProcess(AllFilesOfthatDay);
		return allProcess;
		
	}
	
	
	public abstract List<String> readProcess(List<File> filesOfProcess);
	public abstract File getDOFolder();
	public abstract BuilderFactory getBuilder();
	
	

}
