package graph.input.file;


import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;

import graph.extractor.graph.builder.BuilderFactory;
import graph.extractor.graph.builder.STJBuilder;

public class InputSTJ extends InputFactory{

	public InputSTJ(InputFolder folders) {
		super(folders);
		// TODO Auto-generated constructor stub
	}

	@Override
	public List<String> readProcess(List<File> filesOfProcess) {
		// TODO Auto-generated method stub

		int index = 1;
		List <String> process = new ArrayList<String>();
		boolean isProcess = false;
		StringBuilder temporaryProcess = new StringBuilder();
		filesOfProcess.sort(null);
		for(File file: filesOfProcess )
		{


			try {
				InputStreamReader stream = new InputStreamReader(new FileInputStream(file), "ISO-8859-1");
				@SuppressWarnings("resource")
				BufferedReader bf = new BufferedReader(stream);
				String line= bf.readLine();

				while(line != null){

					if(isProcess)
					{
						temporaryProcess.append(line+"\n");

					}

					String marker = "("+index+")";
					if( line.equals(marker))
					{	
						isProcess = true;
						index++;
						if(temporaryProcess.length() > 10)
						{
							temporaryProcess.setLength(temporaryProcess.length()-marker.length()-2);
							process.add(temporaryProcess.toString());
							temporaryProcess.setLength(0);

						}
					}
					line = bf.readLine();
					if(line != null && line.equals(""))
					{
						line = bf.readLine();
					}


				}


			} catch ( IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}


		}

		return process;
	}


	@Override
	public File getDOFolder() {
		// TODO Auto-generated method stub

		File folder = new File(this.folder.getFolder() +"/stj");
		return folder;



	}

	@Override
	public BuilderFactory getBuilder() {
		// TODO Auto-generated method stub
		return new STJBuilder();
	}





}
